package org.jquantlib.lang.annotation;

/**
 * This annotation serves for documentation purposes only.
 * <p>
 * JVM does not support unsigned integral types.
 * So, in Java and any other JVM backed language, it may become difficult to express these concepts:
 * <pre>
 * unsigned byte ub;
 * unsigned word uw;
 * unsigned int  ui;
 * unsigned long ul;
 * </pre>
 *
 * @see <a href="http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4504839">Bug 4504839</a>
 * @see <a href="http://darksleep.com/player/JavaAndUnsignedTypes.html">Java and Unsigned Types</a>
 * 
 * @author Richard Gomes
 */
public @interface Unsigned {

}
