/*
 Copyright (C) 2007 Richard Gomes

 This source code is release under the BSD License.

 This file is part of JQuantLib, a free-software/open-source library
 for financial quantitative analysts and developers - http://jquantlib.org/

 JQuantLib is free software: you can redistribute it and/or modify it
 under the terms of the JQuantLib license.  You should have received a
 copy of the license along with this program; if not, please email
 <jquant-devel@lists.sourceforge.net>. The license is also available online at
 <http://www.jquantlib.org/index.php/LICENSE.TXT>.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the license for more details.

 JQuantLib is based on QuantLib. http://quantlib.org/
 When applicable, the original copyright notice follows this notice.
 */

package org.jquantlib.util;

/**
 * Mimicks std::pair
 * 
 * @see <a href="http://www.sgi.com/tech/stl/pair.html">std::pair</a> 
 * 
 * @author Richard Gomes
 */
public class Pair<T1, T2> {

	private final T1 first;
	private final T2 second;

	public Pair(final T1 first, final T2 second) {
		this.first = first;
		this.second = second;
	}

	public T1 first() {
		return first;
	}

	public T2 second() {
		return second;
	}

}
